/* DateRange.c generated by valac 0.56.13, the Vala compiler
 * generated from DateRange.vala, do not modify */

/*
 * Copyright 2011-2019 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authored by: Corentin Noël <corentin@elementaryos.org>
 */
/* Represents date range from 'first' to 'last' inclusive */

#include "datetime.h"
#include <glib.h>
#include <gee.h>
#include <glib-object.h>

enum  {
	UTIL_DATE_RANGE_0_PROPERTY,
	UTIL_DATE_RANGE_FIRST_DT_PROPERTY,
	UTIL_DATE_RANGE_LAST_DT_PROPERTY,
	UTIL_DATE_RANGE_NUM_PROPERTIES
};
static GParamSpec* util_date_range_properties[UTIL_DATE_RANGE_NUM_PROPERTIES];
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _UtilDateRangePrivate {
	GDateTime* _first_dt;
	GDateTime* _last_dt;
};

static gint UtilDateRange_private_offset;
static gpointer util_date_range_parent_class = NULL;
static GeeTraversableIface * util_date_range_gee_traversable_parent_iface = NULL;
static GeeIterableIface * util_date_range_gee_iterable_parent_iface = NULL;

static gboolean util_date_range_real_foreach (GeeTraversable* base,
                                       GeeForallFunc f,
                                       gpointer f_target);
static GeeIterator* util_date_range_real_iterator (GeeIterable* base);
static gboolean util_date_range_datetime_equal_func (UtilDateRange* self,
                                              GDateTime* a,
                                              GDateTime* b);
static void util_date_range_finalize (GObject * obj);
static GType util_date_range_get_type_once (void);
static void _vala_util_date_range_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_util_date_range_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);

static inline gpointer
util_date_range_get_instance_private (UtilDateRange* self)
{
	return G_STRUCT_MEMBER_P (self, UtilDateRange_private_offset);
}

static gpointer
_g_date_time_ref0 (gpointer self)
{
#line 29 "../src/DateRange.vala"
	return self ? g_date_time_ref (self) : NULL;
#line 81 "DateRange.c"
}

static gboolean
util_date_range_real_foreach (GeeTraversable* base,
                              GeeForallFunc f,
                              gpointer f_target)
{
	UtilDateRange * self;
	gboolean result;
#line 27 "../src/DateRange.vala"
	self = (UtilDateRange*) base;
#line 93 "DateRange.c"
	{
		GeeIterator* _date_it = NULL;
		GeeIterator* _tmp0_;
#line 28 "../src/DateRange.vala"
		_tmp0_ = gee_iterable_iterator ((GeeIterable*) self);
#line 28 "../src/DateRange.vala"
		_date_it = _tmp0_;
#line 28 "../src/DateRange.vala"
		while (TRUE) {
#line 103 "DateRange.c"
			GeeIterator* _tmp1_;
			GDateTime* date = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			GDateTime* _tmp4_;
			GDateTime* _tmp5_;
#line 28 "../src/DateRange.vala"
			_tmp1_ = _date_it;
#line 28 "../src/DateRange.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 28 "../src/DateRange.vala"
				break;
#line 116 "DateRange.c"
			}
#line 28 "../src/DateRange.vala"
			_tmp2_ = _date_it;
#line 28 "../src/DateRange.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 28 "../src/DateRange.vala"
			date = (GDateTime*) _tmp3_;
#line 29 "../src/DateRange.vala"
			_tmp4_ = date;
#line 29 "../src/DateRange.vala"
			_tmp5_ = _g_date_time_ref0 (_tmp4_);
#line 29 "../src/DateRange.vala"
			if (f (_tmp5_, f_target) == FALSE) {
#line 30 "../src/DateRange.vala"
				result = FALSE;
#line 30 "../src/DateRange.vala"
				_g_date_time_unref0 (date);
#line 30 "../src/DateRange.vala"
				_g_object_unref0 (_date_it);
#line 30 "../src/DateRange.vala"
				return result;
#line 138 "DateRange.c"
			}
#line 28 "../src/DateRange.vala"
			_g_date_time_unref0 (date);
#line 142 "DateRange.c"
		}
#line 28 "../src/DateRange.vala"
		_g_object_unref0 (_date_it);
#line 146 "DateRange.c"
	}
#line 34 "../src/DateRange.vala"
	result = TRUE;
#line 34 "../src/DateRange.vala"
	return result;
#line 152 "DateRange.c"
}

UtilDateRange*
util_date_range_construct (GType object_type,
                           GDateTime* first,
                           GDateTime* last)
{
	UtilDateRange * self = NULL;
#line 37 "../src/DateRange.vala"
	g_return_val_if_fail (first != NULL, NULL);
#line 37 "../src/DateRange.vala"
	g_return_val_if_fail (last != NULL, NULL);
#line 38 "../src/DateRange.vala"
	self = (UtilDateRange*) g_object_new (object_type, "first-dt", first, "last-dt", last, NULL);
#line 37 "../src/DateRange.vala"
	return self;
#line 169 "DateRange.c"
}

UtilDateRange*
util_date_range_new (GDateTime* first,
                     GDateTime* last)
{
#line 37 "../src/DateRange.vala"
	return util_date_range_construct (UTIL_TYPE_DATE_RANGE, first, last);
#line 178 "DateRange.c"
}

gboolean
util_date_range_equals (UtilDateRange* self,
                        UtilDateRange* other)
{
	gboolean _tmp0_ = FALSE;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	gboolean result;
#line 44 "../src/DateRange.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 44 "../src/DateRange.vala"
	g_return_val_if_fail (other != NULL, FALSE);
#line 45 "../src/DateRange.vala"
	_tmp1_ = self->priv->_first_dt;
#line 45 "../src/DateRange.vala"
	_tmp2_ = other->priv->_first_dt;
#line 45 "../src/DateRange.vala"
	if (_tmp1_ == _tmp2_) {
#line 199 "DateRange.c"
		GDateTime* _tmp3_;
		GDateTime* _tmp4_;
#line 45 "../src/DateRange.vala"
		_tmp3_ = self->priv->_last_dt;
#line 45 "../src/DateRange.vala"
		_tmp4_ = other->priv->_last_dt;
#line 45 "../src/DateRange.vala"
		_tmp0_ = _tmp3_ == _tmp4_;
#line 208 "DateRange.c"
	} else {
#line 45 "../src/DateRange.vala"
		_tmp0_ = FALSE;
#line 212 "DateRange.c"
	}
#line 45 "../src/DateRange.vala"
	result = _tmp0_;
#line 45 "../src/DateRange.vala"
	return result;
#line 218 "DateRange.c"
}

static GeeIterator*
util_date_range_real_iterator (GeeIterable* base)
{
	UtilDateRange * self;
	UtilDateIterator* _tmp0_;
	GeeIterator* result;
#line 48 "../src/DateRange.vala"
	self = (UtilDateRange*) base;
#line 49 "../src/DateRange.vala"
	_tmp0_ = util_date_iterator_new (self);
#line 49 "../src/DateRange.vala"
	result = (GeeIterator*) _tmp0_;
#line 49 "../src/DateRange.vala"
	return result;
#line 235 "DateRange.c"
}

GeeList*
util_date_range_to_list (UtilDateRange* self)
{
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	GeeList* result;
#line 52 "../src/DateRange.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 53 "../src/DateRange.vala"
	_tmp0_ = gee_array_list_new (G_TYPE_DATE_TIME, (GBoxedCopyFunc) g_date_time_ref, (GDestroyNotify) g_date_time_unref, (GeeEqualDataFunc) util_date_range_datetime_equal_func, g_object_ref (self), g_object_unref);
#line 53 "../src/DateRange.vala"
	list = _tmp0_;
#line 250 "DateRange.c"
	{
		GeeIterator* _date_it = NULL;
		GeeIterator* _tmp1_;
#line 55 "../src/DateRange.vala"
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) self);
#line 55 "../src/DateRange.vala"
		_date_it = _tmp1_;
#line 55 "../src/DateRange.vala"
		while (TRUE) {
#line 260 "DateRange.c"
			GeeIterator* _tmp2_;
			GDateTime* date = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			GeeArrayList* _tmp5_;
			GDateTime* _tmp6_;
#line 55 "../src/DateRange.vala"
			_tmp2_ = _date_it;
#line 55 "../src/DateRange.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 55 "../src/DateRange.vala"
				break;
#line 273 "DateRange.c"
			}
#line 55 "../src/DateRange.vala"
			_tmp3_ = _date_it;
#line 55 "../src/DateRange.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 55 "../src/DateRange.vala"
			date = (GDateTime*) _tmp4_;
#line 56 "../src/DateRange.vala"
			_tmp5_ = list;
#line 56 "../src/DateRange.vala"
			_tmp6_ = date;
#line 56 "../src/DateRange.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp5_, _tmp6_);
#line 55 "../src/DateRange.vala"
			_g_date_time_unref0 (date);
#line 289 "DateRange.c"
		}
#line 55 "../src/DateRange.vala"
		_g_object_unref0 (_date_it);
#line 293 "DateRange.c"
	}
#line 59 "../src/DateRange.vala"
	result = (GeeList*) list;
#line 59 "../src/DateRange.vala"
	return result;
#line 299 "DateRange.c"
}

static gboolean
util_date_range_datetime_equal_func (UtilDateRange* self,
                                     GDateTime* a,
                                     GDateTime* b)
{
	gboolean result;
#line 63 "../src/DateRange.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 63 "../src/DateRange.vala"
	g_return_val_if_fail (a != NULL, FALSE);
#line 63 "../src/DateRange.vala"
	g_return_val_if_fail (b != NULL, FALSE);
#line 64 "../src/DateRange.vala"
	result = g_date_time_equal (a, b);
#line 64 "../src/DateRange.vala"
	return result;
#line 318 "DateRange.c"
}

GDateTime*
util_date_range_get_first_dt (UtilDateRange* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
#line 24 "../src/DateRange.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 24 "../src/DateRange.vala"
	_tmp0_ = self->priv->_first_dt;
#line 24 "../src/DateRange.vala"
	result = _tmp0_;
#line 24 "../src/DateRange.vala"
	return result;
#line 334 "DateRange.c"
}

static void
util_date_range_set_first_dt (UtilDateRange* self,
                              GDateTime* value)
{
	GDateTime* old_value;
#line 24 "../src/DateRange.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/DateRange.vala"
	old_value = util_date_range_get_first_dt (self);
#line 24 "../src/DateRange.vala"
	if (old_value != value) {
#line 348 "DateRange.c"
		GDateTime* _tmp0_;
#line 24 "../src/DateRange.vala"
		_tmp0_ = _g_date_time_ref0 (value);
#line 24 "../src/DateRange.vala"
		_g_date_time_unref0 (self->priv->_first_dt);
#line 24 "../src/DateRange.vala"
		self->priv->_first_dt = _tmp0_;
#line 24 "../src/DateRange.vala"
		g_object_notify_by_pspec ((GObject *) self, util_date_range_properties[UTIL_DATE_RANGE_FIRST_DT_PROPERTY]);
#line 358 "DateRange.c"
	}
}

GDateTime*
util_date_range_get_last_dt (UtilDateRange* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
#line 25 "../src/DateRange.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 25 "../src/DateRange.vala"
	_tmp0_ = self->priv->_last_dt;
#line 25 "../src/DateRange.vala"
	result = _tmp0_;
#line 25 "../src/DateRange.vala"
	return result;
#line 375 "DateRange.c"
}

static void
util_date_range_set_last_dt (UtilDateRange* self,
                             GDateTime* value)
{
	GDateTime* old_value;
#line 25 "../src/DateRange.vala"
	g_return_if_fail (self != NULL);
#line 25 "../src/DateRange.vala"
	old_value = util_date_range_get_last_dt (self);
#line 25 "../src/DateRange.vala"
	if (old_value != value) {
#line 389 "DateRange.c"
		GDateTime* _tmp0_;
#line 25 "../src/DateRange.vala"
		_tmp0_ = _g_date_time_ref0 (value);
#line 25 "../src/DateRange.vala"
		_g_date_time_unref0 (self->priv->_last_dt);
#line 25 "../src/DateRange.vala"
		self->priv->_last_dt = _tmp0_;
#line 25 "../src/DateRange.vala"
		g_object_notify_by_pspec ((GObject *) self, util_date_range_properties[UTIL_DATE_RANGE_LAST_DT_PROPERTY]);
#line 399 "DateRange.c"
	}
}

static void
util_date_range_class_init (UtilDateRangeClass * klass,
                            gpointer klass_data)
{
#line 23 "../src/DateRange.vala"
	util_date_range_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/DateRange.vala"
	g_type_class_adjust_private_offset (klass, &UtilDateRange_private_offset);
#line 23 "../src/DateRange.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_util_date_range_get_property;
#line 23 "../src/DateRange.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_util_date_range_set_property;
#line 23 "../src/DateRange.vala"
	G_OBJECT_CLASS (klass)->finalize = util_date_range_finalize;
#line 23 "../src/DateRange.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), UTIL_DATE_RANGE_FIRST_DT_PROPERTY, util_date_range_properties[UTIL_DATE_RANGE_FIRST_DT_PROPERTY] = g_param_spec_boxed ("first-dt", "first-dt", "first-dt", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 23 "../src/DateRange.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), UTIL_DATE_RANGE_LAST_DT_PROPERTY, util_date_range_properties[UTIL_DATE_RANGE_LAST_DT_PROPERTY] = g_param_spec_boxed ("last-dt", "last-dt", "last-dt", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 421 "DateRange.c"
}

static GType
util_date_range_gee_traversable_get_g_type (UtilDateRange* self)
{
#line 23 "../src/DateRange.vala"
	return (GType) G_TYPE_DATE_TIME;
#line 429 "DateRange.c"
}

static GBoxedCopyFunc
util_date_range_gee_traversable_get_g_dup_func (UtilDateRange* self)
{
#line 23 "../src/DateRange.vala"
	return (GBoxedCopyFunc) g_date_time_ref;
#line 437 "DateRange.c"
}

static GDestroyNotify
util_date_range_gee_traversable_get_g_destroy_func (UtilDateRange* self)
{
#line 23 "../src/DateRange.vala"
	return (GDestroyNotify) g_date_time_unref;
#line 445 "DateRange.c"
}

static void
util_date_range_gee_traversable_interface_init (GeeTraversableIface * iface,
                                                gpointer iface_data)
{
#line 23 "../src/DateRange.vala"
	util_date_range_gee_traversable_parent_iface = g_type_interface_peek_parent (iface);
#line 23 "../src/DateRange.vala"
	iface->foreach = (gboolean (*) (GeeTraversable*, GeeForallFunc, gpointer)) util_date_range_real_foreach;
#line 23 "../src/DateRange.vala"
	iface->get_g_type = (GType (*) (GeeTraversable *)) util_date_range_gee_traversable_get_g_type;
#line 23 "../src/DateRange.vala"
	iface->get_g_dup_func = (GBoxedCopyFunc (*) (GeeTraversable *)) util_date_range_gee_traversable_get_g_dup_func;
#line 23 "../src/DateRange.vala"
	iface->get_g_destroy_func = (GDestroyNotify (*) (GeeTraversable *)) util_date_range_gee_traversable_get_g_destroy_func;
#line 462 "DateRange.c"
}

static GType
util_date_range_gee_iterable_get_g_type (UtilDateRange* self)
{
#line 23 "../src/DateRange.vala"
	return (GType) G_TYPE_DATE_TIME;
#line 470 "DateRange.c"
}

static GBoxedCopyFunc
util_date_range_gee_iterable_get_g_dup_func (UtilDateRange* self)
{
#line 23 "../src/DateRange.vala"
	return (GBoxedCopyFunc) g_date_time_ref;
#line 478 "DateRange.c"
}

static GDestroyNotify
util_date_range_gee_iterable_get_g_destroy_func (UtilDateRange* self)
{
#line 23 "../src/DateRange.vala"
	return (GDestroyNotify) g_date_time_unref;
#line 486 "DateRange.c"
}

static void
util_date_range_gee_iterable_interface_init (GeeIterableIface * iface,
                                             gpointer iface_data)
{
#line 23 "../src/DateRange.vala"
	util_date_range_gee_iterable_parent_iface = g_type_interface_peek_parent (iface);
#line 23 "../src/DateRange.vala"
	iface->iterator = (GeeIterator* (*) (GeeIterable*)) util_date_range_real_iterator;
#line 23 "../src/DateRange.vala"
	iface->get_g_type = (GType (*) (GeeIterable *)) util_date_range_gee_iterable_get_g_type;
#line 23 "../src/DateRange.vala"
	iface->get_g_dup_func = (GBoxedCopyFunc (*) (GeeIterable *)) util_date_range_gee_iterable_get_g_dup_func;
#line 23 "../src/DateRange.vala"
	iface->get_g_destroy_func = (GDestroyNotify (*) (GeeIterable *)) util_date_range_gee_iterable_get_g_destroy_func;
#line 503 "DateRange.c"
}

static void
util_date_range_instance_init (UtilDateRange * self,
                               gpointer klass)
{
#line 23 "../src/DateRange.vala"
	self->priv = util_date_range_get_instance_private (self);
#line 512 "DateRange.c"
}

static void
util_date_range_finalize (GObject * obj)
{
	UtilDateRange * self;
#line 23 "../src/DateRange.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, UTIL_TYPE_DATE_RANGE, UtilDateRange);
#line 24 "../src/DateRange.vala"
	_g_date_time_unref0 (self->priv->_first_dt);
#line 25 "../src/DateRange.vala"
	_g_date_time_unref0 (self->priv->_last_dt);
#line 23 "../src/DateRange.vala"
	G_OBJECT_CLASS (util_date_range_parent_class)->finalize (obj);
#line 527 "DateRange.c"
}

static GType
util_date_range_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (UtilDateRangeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) util_date_range_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UtilDateRange), 0, (GInstanceInitFunc) util_date_range_instance_init, NULL };
	static const GInterfaceInfo gee_traversable_info = { (GInterfaceInitFunc) util_date_range_gee_traversable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	static const GInterfaceInfo gee_iterable_info = { (GInterfaceInitFunc) util_date_range_gee_iterable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType util_date_range_type_id;
	util_date_range_type_id = g_type_register_static (G_TYPE_OBJECT, "UtilDateRange", &g_define_type_info, 0);
	g_type_add_interface_static (util_date_range_type_id, GEE_TYPE_TRAVERSABLE, &gee_traversable_info);
	g_type_add_interface_static (util_date_range_type_id, GEE_TYPE_ITERABLE, &gee_iterable_info);
	UtilDateRange_private_offset = g_type_add_instance_private (util_date_range_type_id, sizeof (UtilDateRangePrivate));
	return util_date_range_type_id;
}

GType
util_date_range_get_type (void)
{
	static volatile gsize util_date_range_type_id__once = 0;
	if (g_once_init_enter (&util_date_range_type_id__once)) {
		GType util_date_range_type_id;
		util_date_range_type_id = util_date_range_get_type_once ();
		g_once_init_leave (&util_date_range_type_id__once, util_date_range_type_id);
	}
	return util_date_range_type_id__once;
}

static void
_vala_util_date_range_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	UtilDateRange * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, UTIL_TYPE_DATE_RANGE, UtilDateRange);
#line 23 "../src/DateRange.vala"
	switch (property_id) {
#line 23 "../src/DateRange.vala"
		case UTIL_DATE_RANGE_FIRST_DT_PROPERTY:
#line 23 "../src/DateRange.vala"
		g_value_set_boxed (value, util_date_range_get_first_dt (self));
#line 23 "../src/DateRange.vala"
		break;
#line 23 "../src/DateRange.vala"
		case UTIL_DATE_RANGE_LAST_DT_PROPERTY:
#line 23 "../src/DateRange.vala"
		g_value_set_boxed (value, util_date_range_get_last_dt (self));
#line 23 "../src/DateRange.vala"
		break;
#line 578 "DateRange.c"
		default:
#line 23 "../src/DateRange.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/DateRange.vala"
		break;
#line 584 "DateRange.c"
	}
}

static void
_vala_util_date_range_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	UtilDateRange * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, UTIL_TYPE_DATE_RANGE, UtilDateRange);
#line 23 "../src/DateRange.vala"
	switch (property_id) {
#line 23 "../src/DateRange.vala"
		case UTIL_DATE_RANGE_FIRST_DT_PROPERTY:
#line 23 "../src/DateRange.vala"
		util_date_range_set_first_dt (self, g_value_get_boxed (value));
#line 23 "../src/DateRange.vala"
		break;
#line 23 "../src/DateRange.vala"
		case UTIL_DATE_RANGE_LAST_DT_PROPERTY:
#line 23 "../src/DateRange.vala"
		util_date_range_set_last_dt (self, g_value_get_boxed (value));
#line 23 "../src/DateRange.vala"
		break;
#line 610 "DateRange.c"
		default:
#line 23 "../src/DateRange.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/DateRange.vala"
		break;
#line 616 "DateRange.c"
	}
}

