/* GridDay.c generated by valac 0.56.13, the Vala compiler
 * generated from GridDay.vala, do not modify */

/*-
 * Copyright 2011–2020 elementary, Inc. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Maxwell Barvian
 *              Corentin Noël <corentin@elementaryos.org>
 */

#include "datetime.h"
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <libedataserver/libedataserver.h>
#include <libical-glib/libical-glib.h>
#include <gio/gio.h>
#include <granite.h>
#include <gdk/gdk.h>

enum  {
	DATE_TIME_WIDGETS_GRID_DAY_0_PROPERTY,
	DATE_TIME_WIDGETS_GRID_DAY_DATE_PROPERTY,
	DATE_TIME_WIDGETS_GRID_DAY_NUM_PROPERTIES
};
static GParamSpec* date_time_widgets_grid_day_properties[DATE_TIME_WIDGETS_GRID_DAY_NUM_PROPERTIES];
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	DATE_TIME_WIDGETS_GRID_DAY_ON_EVENT_ADD_SIGNAL,
	DATE_TIME_WIDGETS_GRID_DAY_NUM_SIGNALS
};
static guint date_time_widgets_grid_day_signals[DATE_TIME_WIDGETS_GRID_DAY_NUM_SIGNALS] = {0};

struct _DateTimeWidgetsGridDayPrivate {
	GDateTime* _date;
	GeeHashMap* component_dots;
	GtkBox* event_box;
	GtkLabel* label;
	gboolean valid_grab;
};

static gint DateTimeWidgetsGridDay_private_offset;
static gpointer date_time_widgets_grid_day_parent_class = NULL;
static GtkCssProvider* date_time_widgets_grid_day_provider;
static GtkCssProvider* date_time_widgets_grid_day_provider = NULL;

static void date_time_widgets_grid_day_real_grab_focus (GtkWidget* base);
static gboolean date_time_widgets_grid_day_on_button_press (DateTimeWidgetsGridDay* self,
                                                     GdkEventButton* event);
static gboolean date_time_widgets_grid_day_on_key_press (DateTimeWidgetsGridDay* self,
                                                  GdkEventKey* event);
static GObject * date_time_widgets_grid_day_constructor (GType type,
                                                  guint n_construct_properties,
                                                  GObjectConstructParam * construct_properties);
static gboolean _date_time_widgets_grid_day_on_button_press_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                                    GdkEventButton* event,
                                                                                    gpointer self);
static gboolean _date_time_widgets_grid_day_on_key_press_gtk_widget_key_press_event (GtkWidget* _sender,
                                                                              GdkEventKey* event,
                                                                              gpointer self);
static gboolean _date_time_widgets_grid_day___lambda22_ (DateTimeWidgetsGridDay* self,
                                                  GBinding* binding,
                                                  GValue* from_value,
                                                  GValue* to_value);
static gboolean __date_time_widgets_grid_day___lambda22__gbinding_transform_func (GBinding* binding,
                                                                           GValue* from_value,
                                                                           GValue* to_value,
                                                                           gpointer self);
static void date_time_widgets_grid_day_finalize (GObject * obj);
static GType date_time_widgets_grid_day_get_type_once (void);
static void _vala_date_time_widgets_grid_day_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec);
static void _vala_date_time_widgets_grid_day_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec);

static inline gpointer
date_time_widgets_grid_day_get_instance_private (DateTimeWidgetsGridDay* self)
{
	return G_STRUCT_MEMBER_P (self, DateTimeWidgetsGridDay_private_offset);
}

DateTimeWidgetsGridDay*
date_time_widgets_grid_day_construct (GType object_type,
                                      GDateTime* date)
{
	DateTimeWidgetsGridDay * self = NULL;
#line 39 "../src/Widgets/calendar/GridDay.vala"
	g_return_val_if_fail (date != NULL, NULL);
#line 40 "../src/Widgets/calendar/GridDay.vala"
	self = (DateTimeWidgetsGridDay*) g_object_new (object_type, "date", date, NULL);
#line 39 "../src/Widgets/calendar/GridDay.vala"
	return self;
#line 116 "GridDay.c"
}

DateTimeWidgetsGridDay*
date_time_widgets_grid_day_new (GDateTime* date)
{
#line 39 "../src/Widgets/calendar/GridDay.vala"
	return date_time_widgets_grid_day_construct (DATE_TIME_WIDGETS_TYPE_GRID_DAY, date);
#line 124 "GridDay.c"
}

void
date_time_widgets_grid_day_add_component_dot (DateTimeWidgetsGridDay* self,
                                              ESource* source,
                                              ICalComponent* ical)
{
	GeeHashMap* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gchar* component_uid = NULL;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	GeeHashMap* _tmp5_;
	const gchar* _tmp6_;
#line 90 "../src/Widgets/calendar/GridDay.vala"
	g_return_if_fail (self != NULL);
#line 90 "../src/Widgets/calendar/GridDay.vala"
	g_return_if_fail (source != NULL);
#line 90 "../src/Widgets/calendar/GridDay.vala"
	g_return_if_fail (ical != NULL);
#line 91 "../src/Widgets/calendar/GridDay.vala"
	_tmp0_ = self->priv->component_dots;
#line 91 "../src/Widgets/calendar/GridDay.vala"
	_tmp1_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp0_);
#line 91 "../src/Widgets/calendar/GridDay.vala"
	_tmp2_ = _tmp1_;
#line 91 "../src/Widgets/calendar/GridDay.vala"
	if (_tmp2_ >= 3) {
#line 92 "../src/Widgets/calendar/GridDay.vala"
		return;
#line 156 "GridDay.c"
	}
#line 95 "../src/Widgets/calendar/GridDay.vala"
	_tmp3_ = i_cal_component_get_uid (ical);
#line 95 "../src/Widgets/calendar/GridDay.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 95 "../src/Widgets/calendar/GridDay.vala"
	component_uid = _tmp4_;
#line 96 "../src/Widgets/calendar/GridDay.vala"
	_tmp5_ = self->priv->component_dots;
#line 96 "../src/Widgets/calendar/GridDay.vala"
	_tmp6_ = component_uid;
#line 96 "../src/Widgets/calendar/GridDay.vala"
	if (!gee_abstract_map_has_key ((GeeAbstractMap*) _tmp5_, _tmp6_)) {
#line 170 "GridDay.c"
		GtkImage* event_dot = NULL;
		GThemedIcon* _tmp7_;
		GtkImage* _tmp8_ = NULL;
		GtkStyleContext* style_context = NULL;
		GtkImage* _tmp9_;
		GtkStyleContext* _tmp10_;
		GtkStyleContext* _tmp11_;
		GtkStyleContext* _tmp12_;
		GtkCssProvider* _tmp13_;
		ESourceSelectable* source_selectable = NULL;
		ESourceSelectable* _tmp16_;
		GtkImage* _tmp17_;
		GeeHashMap* _tmp18_;
		const gchar* _tmp19_;
		GtkImage* _tmp20_;
		GtkBox* _tmp21_;
		GtkImage* _tmp22_;
#line 97 "../src/Widgets/calendar/GridDay.vala"
		_tmp7_ = (GThemedIcon*) g_themed_icon_new ("pager-checked-symbolic");
#line 97 "../src/Widgets/calendar/GridDay.vala"
		_tmp8_ = (GtkImage*) gtk_image_new ();
#line 97 "../src/Widgets/calendar/GridDay.vala"
		g_object_set (_tmp8_, "gicon", (GIcon*) _tmp7_, NULL);
#line 97 "../src/Widgets/calendar/GridDay.vala"
		_g_object_unref0 (_tmp7_);
#line 97 "../src/Widgets/calendar/GridDay.vala"
		gtk_image_set_pixel_size (_tmp8_, 6);
#line 97 "../src/Widgets/calendar/GridDay.vala"
		g_object_ref_sink (_tmp8_);
#line 97 "../src/Widgets/calendar/GridDay.vala"
		event_dot = _tmp8_;
#line 102 "../src/Widgets/calendar/GridDay.vala"
		_tmp9_ = event_dot;
#line 102 "../src/Widgets/calendar/GridDay.vala"
		_tmp10_ = gtk_widget_get_style_context ((GtkWidget*) _tmp9_);
#line 102 "../src/Widgets/calendar/GridDay.vala"
		style_context = _tmp10_;
#line 103 "../src/Widgets/calendar/GridDay.vala"
		_tmp11_ = style_context;
#line 103 "../src/Widgets/calendar/GridDay.vala"
		gtk_style_context_add_class (_tmp11_, GRANITE_STYLE_CLASS_ACCENT);
#line 104 "../src/Widgets/calendar/GridDay.vala"
		_tmp12_ = style_context;
#line 104 "../src/Widgets/calendar/GridDay.vala"
		_tmp13_ = date_time_widgets_grid_day_provider;
#line 104 "../src/Widgets/calendar/GridDay.vala"
		gtk_style_context_add_provider (_tmp12_, (GtkStyleProvider*) _tmp13_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 106 "../src/Widgets/calendar/GridDay.vala"
		source_selectable = NULL;
#line 107 "../src/Widgets/calendar/GridDay.vala"
		if (e_source_has_extension (source, E_SOURCE_EXTENSION_TASK_LIST)) {
#line 222 "GridDay.c"
			ESourceExtension* _tmp14_;
#line 108 "../src/Widgets/calendar/GridDay.vala"
			_tmp14_ = e_source_get_extension (source, E_SOURCE_EXTENSION_TASK_LIST);
#line 108 "../src/Widgets/calendar/GridDay.vala"
			source_selectable = G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, e_source_selectable_get_type (), ESourceSelectable);
#line 228 "GridDay.c"
		} else {
			ESourceExtension* _tmp15_;
#line 110 "../src/Widgets/calendar/GridDay.vala"
			_tmp15_ = e_source_get_extension (source, E_SOURCE_EXTENSION_CALENDAR);
#line 110 "../src/Widgets/calendar/GridDay.vala"
			source_selectable = G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, e_source_selectable_get_type (), ESourceSelectable);
#line 235 "GridDay.c"
		}
#line 112 "../src/Widgets/calendar/GridDay.vala"
		_tmp16_ = source_selectable;
#line 112 "../src/Widgets/calendar/GridDay.vala"
		_tmp17_ = event_dot;
#line 112 "../src/Widgets/calendar/GridDay.vala"
		util_set_component_calendar_color (_tmp16_, (GtkWidget*) _tmp17_);
#line 114 "../src/Widgets/calendar/GridDay.vala"
		_tmp18_ = self->priv->component_dots;
#line 114 "../src/Widgets/calendar/GridDay.vala"
		_tmp19_ = component_uid;
#line 114 "../src/Widgets/calendar/GridDay.vala"
		_tmp20_ = event_dot;
#line 114 "../src/Widgets/calendar/GridDay.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp18_, _tmp19_, (GtkWidget*) _tmp20_);
#line 116 "../src/Widgets/calendar/GridDay.vala"
		_tmp21_ = self->priv->event_box;
#line 116 "../src/Widgets/calendar/GridDay.vala"
		_tmp22_ = event_dot;
#line 116 "../src/Widgets/calendar/GridDay.vala"
		gtk_container_add ((GtkContainer*) _tmp21_, (GtkWidget*) _tmp22_);
#line 96 "../src/Widgets/calendar/GridDay.vala"
		_g_object_unref0 (event_dot);
#line 259 "GridDay.c"
	}
#line 90 "../src/Widgets/calendar/GridDay.vala"
	_g_free0 (component_uid);
#line 263 "GridDay.c"
}

void
date_time_widgets_grid_day_remove_component_dot (DateTimeWidgetsGridDay* self,
                                                 const gchar* component_uid)
{
	GtkWidget* dot = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	GtkWidget* _tmp2_;
#line 120 "../src/Widgets/calendar/GridDay.vala"
	g_return_if_fail (self != NULL);
#line 120 "../src/Widgets/calendar/GridDay.vala"
	g_return_if_fail (component_uid != NULL);
#line 121 "../src/Widgets/calendar/GridDay.vala"
	_tmp0_ = self->priv->component_dots;
#line 121 "../src/Widgets/calendar/GridDay.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, component_uid);
#line 121 "../src/Widgets/calendar/GridDay.vala"
	dot = (GtkWidget*) _tmp1_;
#line 122 "../src/Widgets/calendar/GridDay.vala"
	_tmp2_ = dot;
#line 122 "../src/Widgets/calendar/GridDay.vala"
	if (_tmp2_ != NULL) {
#line 288 "GridDay.c"
		GtkWidget* _tmp3_;
		GeeHashMap* _tmp4_;
#line 123 "../src/Widgets/calendar/GridDay.vala"
		_tmp3_ = dot;
#line 123 "../src/Widgets/calendar/GridDay.vala"
		gtk_widget_destroy (_tmp3_);
#line 124 "../src/Widgets/calendar/GridDay.vala"
		_tmp4_ = self->priv->component_dots;
#line 124 "../src/Widgets/calendar/GridDay.vala"
		gee_abstract_map_unset ((GeeAbstractMap*) _tmp4_, component_uid, NULL);
#line 299 "GridDay.c"
	}
#line 120 "../src/Widgets/calendar/GridDay.vala"
	_g_object_unref0 (dot);
#line 303 "GridDay.c"
}

void
date_time_widgets_grid_day_set_selected (DateTimeWidgetsGridDay* self,
                                         gboolean selected)
{
#line 128 "../src/Widgets/calendar/GridDay.vala"
	g_return_if_fail (self != NULL);
#line 129 "../src/Widgets/calendar/GridDay.vala"
	if (selected) {
#line 130 "../src/Widgets/calendar/GridDay.vala"
		gtk_widget_set_state_flags ((GtkWidget*) self, GTK_STATE_FLAG_SELECTED, TRUE);
#line 316 "GridDay.c"
	} else {
#line 132 "../src/Widgets/calendar/GridDay.vala"
		gtk_widget_set_state_flags ((GtkWidget*) self, GTK_STATE_FLAG_NORMAL, TRUE);
#line 320 "GridDay.c"
	}
}

void
date_time_widgets_grid_day_grab_focus_force (DateTimeWidgetsGridDay* self)
{
#line 136 "../src/Widgets/calendar/GridDay.vala"
	g_return_if_fail (self != NULL);
#line 137 "../src/Widgets/calendar/GridDay.vala"
	self->priv->valid_grab = TRUE;
#line 138 "../src/Widgets/calendar/GridDay.vala"
	gtk_widget_grab_focus ((GtkWidget*) self);
#line 333 "GridDay.c"
}

static void
date_time_widgets_grid_day_real_grab_focus (GtkWidget* base)
{
	DateTimeWidgetsGridDay * self;
#line 141 "../src/Widgets/calendar/GridDay.vala"
	self = (DateTimeWidgetsGridDay*) base;
#line 142 "../src/Widgets/calendar/GridDay.vala"
	if (self->priv->valid_grab) {
#line 143 "../src/Widgets/calendar/GridDay.vala"
		GTK_WIDGET_CLASS (date_time_widgets_grid_day_parent_class)->grab_focus ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_event_box_get_type (), GtkEventBox));
#line 144 "../src/Widgets/calendar/GridDay.vala"
		self->priv->valid_grab = FALSE;
#line 348 "GridDay.c"
	}
}

void
date_time_widgets_grid_day_sensitive_container (DateTimeWidgetsGridDay* self,
                                                gboolean sens)
{
	GtkLabel* _tmp0_;
	GtkBox* _tmp1_;
#line 148 "../src/Widgets/calendar/GridDay.vala"
	g_return_if_fail (self != NULL);
#line 149 "../src/Widgets/calendar/GridDay.vala"
	_tmp0_ = self->priv->label;
#line 149 "../src/Widgets/calendar/GridDay.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, sens);
#line 150 "../src/Widgets/calendar/GridDay.vala"
	_tmp1_ = self->priv->event_box;
#line 150 "../src/Widgets/calendar/GridDay.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp1_, sens);
#line 368 "GridDay.c"
}

static gboolean
date_time_widgets_grid_day_on_button_press (DateTimeWidgetsGridDay* self,
                                            GdkEventButton* event)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 153 "../src/Widgets/calendar/GridDay.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 153 "../src/Widgets/calendar/GridDay.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 154 "../src/Widgets/calendar/GridDay.vala"
	if (event->type == GDK_2BUTTON_PRESS) {
#line 154 "../src/Widgets/calendar/GridDay.vala"
		_tmp0_ = event->button == ((guint) GDK_BUTTON_PRIMARY);
#line 385 "GridDay.c"
	} else {
#line 154 "../src/Widgets/calendar/GridDay.vala"
		_tmp0_ = FALSE;
#line 389 "GridDay.c"
	}
#line 154 "../src/Widgets/calendar/GridDay.vala"
	if (_tmp0_) {
#line 393 "GridDay.c"
		GDateTime* _tmp1_;
#line 155 "../src/Widgets/calendar/GridDay.vala"
		_tmp1_ = self->priv->_date;
#line 155 "../src/Widgets/calendar/GridDay.vala"
		g_signal_emit (self, date_time_widgets_grid_day_signals[DATE_TIME_WIDGETS_GRID_DAY_ON_EVENT_ADD_SIGNAL], 0, _tmp1_);
#line 399 "GridDay.c"
	}
#line 157 "../src/Widgets/calendar/GridDay.vala"
	self->priv->valid_grab = TRUE;
#line 158 "../src/Widgets/calendar/GridDay.vala"
	gtk_widget_grab_focus ((GtkWidget*) self);
#line 159 "../src/Widgets/calendar/GridDay.vala"
	result = FALSE;
#line 159 "../src/Widgets/calendar/GridDay.vala"
	return result;
#line 409 "GridDay.c"
}

static gboolean
date_time_widgets_grid_day_on_key_press (DateTimeWidgetsGridDay* self,
                                         GdkEventKey* event)
{
	gboolean result;
#line 162 "../src/Widgets/calendar/GridDay.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 162 "../src/Widgets/calendar/GridDay.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 163 "../src/Widgets/calendar/GridDay.vala"
	if (event->keyval == gdk_keyval_from_name ("Return")) {
#line 423 "GridDay.c"
		GDateTime* _tmp0_;
#line 164 "../src/Widgets/calendar/GridDay.vala"
		_tmp0_ = self->priv->_date;
#line 164 "../src/Widgets/calendar/GridDay.vala"
		g_signal_emit (self, date_time_widgets_grid_day_signals[DATE_TIME_WIDGETS_GRID_DAY_ON_EVENT_ADD_SIGNAL], 0, _tmp0_);
#line 165 "../src/Widgets/calendar/GridDay.vala"
		result = TRUE;
#line 165 "../src/Widgets/calendar/GridDay.vala"
		return result;
#line 433 "GridDay.c"
	}
#line 168 "../src/Widgets/calendar/GridDay.vala"
	result = FALSE;
#line 168 "../src/Widgets/calendar/GridDay.vala"
	return result;
#line 439 "GridDay.c"
}

GDateTime*
date_time_widgets_grid_day_get_date (DateTimeWidgetsGridDay* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
#line 30 "../src/Widgets/calendar/GridDay.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "../src/Widgets/calendar/GridDay.vala"
	_tmp0_ = self->priv->_date;
#line 30 "../src/Widgets/calendar/GridDay.vala"
	result = _tmp0_;
#line 30 "../src/Widgets/calendar/GridDay.vala"
	return result;
#line 455 "GridDay.c"
}

static gpointer
_g_date_time_ref0 (gpointer self)
{
#line 30 "../src/Widgets/calendar/GridDay.vala"
	return self ? g_date_time_ref (self) : NULL;
#line 463 "GridDay.c"
}

void
date_time_widgets_grid_day_set_date (DateTimeWidgetsGridDay* self,
                                     GDateTime* value)
{
	GDateTime* old_value;
#line 30 "../src/Widgets/calendar/GridDay.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/Widgets/calendar/GridDay.vala"
	old_value = date_time_widgets_grid_day_get_date (self);
#line 30 "../src/Widgets/calendar/GridDay.vala"
	if (old_value != value) {
#line 477 "GridDay.c"
		GDateTime* _tmp0_;
#line 30 "../src/Widgets/calendar/GridDay.vala"
		_tmp0_ = _g_date_time_ref0 (value);
#line 30 "../src/Widgets/calendar/GridDay.vala"
		_g_date_time_unref0 (self->priv->_date);
#line 30 "../src/Widgets/calendar/GridDay.vala"
		self->priv->_date = _tmp0_;
#line 30 "../src/Widgets/calendar/GridDay.vala"
		g_object_notify_by_pspec ((GObject *) self, date_time_widgets_grid_day_properties[DATE_TIME_WIDGETS_GRID_DAY_DATE_PROPERTY]);
#line 487 "GridDay.c"
	}
}

static gboolean
_date_time_widgets_grid_day_on_button_press_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                           GdkEventButton* event,
                                                                           gpointer self)
{
	gboolean result;
	result = date_time_widgets_grid_day_on_button_press ((DateTimeWidgetsGridDay*) self, event);
#line 79 "../src/Widgets/calendar/GridDay.vala"
	return result;
#line 500 "GridDay.c"
}

static gboolean
_date_time_widgets_grid_day_on_key_press_gtk_widget_key_press_event (GtkWidget* _sender,
                                                                     GdkEventKey* event,
                                                                     gpointer self)
{
	gboolean result;
	result = date_time_widgets_grid_day_on_key_press ((DateTimeWidgetsGridDay*) self, event);
#line 80 "../src/Widgets/calendar/GridDay.vala"
	return result;
#line 512 "GridDay.c"
}

static gboolean
_date_time_widgets_grid_day___lambda22_ (DateTimeWidgetsGridDay* self,
                                         GBinding* binding,
                                         GValue* from_value,
                                         GValue* to_value)
{
	GDateTime* new_date = NULL;
	void* _tmp0_;
	GDateTime* _tmp1_;
	gchar* _tmp2_;
	gboolean result;
#line 81 "../src/Widgets/calendar/GridDay.vala"
	g_return_val_if_fail (binding != NULL, FALSE);
#line 81 "../src/Widgets/calendar/GridDay.vala"
	g_return_val_if_fail (from_value != NULL, FALSE);
#line 81 "../src/Widgets/calendar/GridDay.vala"
	g_return_val_if_fail (to_value != NULL, FALSE);
#line 82 "../src/Widgets/calendar/GridDay.vala"
	_tmp0_ = g_value_get_boxed (from_value);
#line 82 "../src/Widgets/calendar/GridDay.vala"
	new_date = (GDateTime*) _tmp0_;
#line 83 "../src/Widgets/calendar/GridDay.vala"
	_tmp1_ = new_date;
#line 83 "../src/Widgets/calendar/GridDay.vala"
	_tmp2_ = g_strdup_printf ("%i", g_date_time_get_day_of_month (_tmp1_));
#line 83 "../src/Widgets/calendar/GridDay.vala"
	g_value_take_string (to_value, _tmp2_);
#line 84 "../src/Widgets/calendar/GridDay.vala"
	result = TRUE;
#line 84 "../src/Widgets/calendar/GridDay.vala"
	return result;
#line 546 "GridDay.c"
}

static gboolean
__date_time_widgets_grid_day___lambda22__gbinding_transform_func (GBinding* binding,
                                                                  GValue* from_value,
                                                                  GValue* to_value,
                                                                  gpointer self)
{
	gboolean result;
	result = _date_time_widgets_grid_day___lambda22_ ((DateTimeWidgetsGridDay*) self, binding, from_value, to_value);
#line 81 "../src/Widgets/calendar/GridDay.vala"
	return result;
#line 559 "GridDay.c"
}

static GObject *
date_time_widgets_grid_day_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	DateTimeWidgetsGridDay * self;
	GtkLabel* _tmp0_;
	GtkStyleContext* label_style_context = NULL;
	GtkLabel* _tmp1_;
	GtkStyleContext* _tmp2_;
	GtkStyleContext* _tmp3_;
	GtkCssProvider* _tmp4_;
	GtkStyleContext* _tmp5_;
	GtkBox* _tmp6_ = NULL;
	GtkBox* box = NULL;
	GtkBox* _tmp7_ = NULL;
	GtkBox* _tmp8_;
	GtkLabel* _tmp9_;
	GtkBox* _tmp10_;
	GtkBox* _tmp11_;
	GdkEventMask _tmp12_;
	GdkEventMask _tmp13_;
	GdkEventMask _tmp14_;
	GdkEventMask _tmp15_;
	GtkStyleContext* _tmp16_;
	GtkCssProvider* _tmp17_;
	GtkBox* _tmp18_;
	GtkLabel* _tmp19_;
	GeeHashMap* _tmp20_;
#line 48 "../src/Widgets/calendar/GridDay.vala"
	parent_class = G_OBJECT_CLASS (date_time_widgets_grid_day_parent_class);
#line 48 "../src/Widgets/calendar/GridDay.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 48 "../src/Widgets/calendar/GridDay.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DATE_TIME_WIDGETS_TYPE_GRID_DAY, DateTimeWidgetsGridDay);
#line 49 "../src/Widgets/calendar/GridDay.vala"
	_tmp0_ = (GtkLabel*) gtk_label_new (NULL);
#line 49 "../src/Widgets/calendar/GridDay.vala"
	g_object_ref_sink (_tmp0_);
#line 49 "../src/Widgets/calendar/GridDay.vala"
	_g_object_unref0 (self->priv->label);
#line 49 "../src/Widgets/calendar/GridDay.vala"
	self->priv->label = _tmp0_;
#line 51 "../src/Widgets/calendar/GridDay.vala"
	_tmp1_ = self->priv->label;
#line 51 "../src/Widgets/calendar/GridDay.vala"
	_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) _tmp1_);
#line 51 "../src/Widgets/calendar/GridDay.vala"
	label_style_context = _tmp2_;
#line 52 "../src/Widgets/calendar/GridDay.vala"
	_tmp3_ = label_style_context;
#line 52 "../src/Widgets/calendar/GridDay.vala"
	_tmp4_ = date_time_widgets_grid_day_provider;
#line 52 "../src/Widgets/calendar/GridDay.vala"
	gtk_style_context_add_provider (_tmp3_, (GtkStyleProvider*) _tmp4_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 53 "../src/Widgets/calendar/GridDay.vala"
	_tmp5_ = label_style_context;
#line 53 "../src/Widgets/calendar/GridDay.vala"
	gtk_style_context_add_class (_tmp5_, "circular");
#line 55 "../src/Widgets/calendar/GridDay.vala"
	_tmp6_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 55 "../src/Widgets/calendar/GridDay.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp6_, GTK_ALIGN_CENTER);
#line 55 "../src/Widgets/calendar/GridDay.vala"
	g_object_set ((GtkWidget*) _tmp6_, "height-request", 6, NULL);
#line 55 "../src/Widgets/calendar/GridDay.vala"
	g_object_ref_sink (_tmp6_);
#line 55 "../src/Widgets/calendar/GridDay.vala"
	_g_object_unref0 (self->priv->event_box);
#line 55 "../src/Widgets/calendar/GridDay.vala"
	self->priv->event_box = _tmp6_;
#line 60 "../src/Widgets/calendar/GridDay.vala"
	_tmp7_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 60 "../src/Widgets/calendar/GridDay.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp7_, GTK_ALIGN_CENTER);
#line 60 "../src/Widgets/calendar/GridDay.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp7_, GTK_ALIGN_CENTER);
#line 60 "../src/Widgets/calendar/GridDay.vala"
	g_object_ref_sink (_tmp7_);
#line 60 "../src/Widgets/calendar/GridDay.vala"
	box = _tmp7_;
#line 65 "../src/Widgets/calendar/GridDay.vala"
	_tmp8_ = box;
#line 65 "../src/Widgets/calendar/GridDay.vala"
	_tmp9_ = self->priv->label;
#line 65 "../src/Widgets/calendar/GridDay.vala"
	gtk_container_add ((GtkContainer*) _tmp8_, (GtkWidget*) _tmp9_);
#line 66 "../src/Widgets/calendar/GridDay.vala"
	_tmp10_ = box;
#line 66 "../src/Widgets/calendar/GridDay.vala"
	_tmp11_ = self->priv->event_box;
#line 66 "../src/Widgets/calendar/GridDay.vala"
	gtk_container_add ((GtkContainer*) _tmp10_, (GtkWidget*) _tmp11_);
#line 68 "../src/Widgets/calendar/GridDay.vala"
	gtk_widget_set_can_focus ((GtkWidget*) self, TRUE);
#line 69 "../src/Widgets/calendar/GridDay.vala"
	_tmp12_ = gtk_widget_get_events ((GtkWidget*) self);
#line 69 "../src/Widgets/calendar/GridDay.vala"
	_tmp13_ = _tmp12_;
#line 69 "../src/Widgets/calendar/GridDay.vala"
	gtk_widget_set_events ((GtkWidget*) self, _tmp13_ | GDK_BUTTON_PRESS_MASK);
#line 70 "../src/Widgets/calendar/GridDay.vala"
	_tmp14_ = gtk_widget_get_events ((GtkWidget*) self);
#line 70 "../src/Widgets/calendar/GridDay.vala"
	_tmp15_ = _tmp14_;
#line 70 "../src/Widgets/calendar/GridDay.vala"
	gtk_widget_set_events ((GtkWidget*) self, _tmp15_ | GDK_KEY_PRESS_MASK);
#line 71 "../src/Widgets/calendar/GridDay.vala"
	gtk_widget_class_set_css_name (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "grid-day");
#line 72 "../src/Widgets/calendar/GridDay.vala"
	gtk_widget_set_halign ((GtkWidget*) self, GTK_ALIGN_CENTER);
#line 73 "../src/Widgets/calendar/GridDay.vala"
	gtk_widget_set_hexpand ((GtkWidget*) self, TRUE);
#line 74 "../src/Widgets/calendar/GridDay.vala"
	_tmp16_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 74 "../src/Widgets/calendar/GridDay.vala"
	_tmp17_ = date_time_widgets_grid_day_provider;
#line 74 "../src/Widgets/calendar/GridDay.vala"
	gtk_style_context_add_provider (_tmp16_, (GtkStyleProvider*) _tmp17_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 75 "../src/Widgets/calendar/GridDay.vala"
	_tmp18_ = box;
#line 75 "../src/Widgets/calendar/GridDay.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp18_);
#line 76 "../src/Widgets/calendar/GridDay.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 79 "../src/Widgets/calendar/GridDay.vala"
	g_signal_connect_object ((GtkWidget*) self, "button-press-event", (GCallback) _date_time_widgets_grid_day_on_button_press_gtk_widget_button_press_event, self, 0);
#line 80 "../src/Widgets/calendar/GridDay.vala"
	g_signal_connect_object ((GtkWidget*) self, "key-press-event", (GCallback) _date_time_widgets_grid_day_on_key_press_gtk_widget_key_press_event, self, 0);
#line 81 "../src/Widgets/calendar/GridDay.vala"
	_tmp19_ = self->priv->label;
#line 81 "../src/Widgets/calendar/GridDay.vala"
	g_object_bind_property_with_closures ((GObject*) self, "date", (GObject*) _tmp19_, "label", G_BINDING_SYNC_CREATE, (GClosure*) ((__date_time_widgets_grid_day___lambda22__gbinding_transform_func == NULL) ? NULL : g_cclosure_new ((GCallback) __date_time_widgets_grid_day___lambda22__gbinding_transform_func, g_object_ref (self), (GClosureNotify) g_object_unref)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 87 "../src/Widgets/calendar/GridDay.vala"
	_tmp20_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, gtk_widget_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 87 "../src/Widgets/calendar/GridDay.vala"
	_g_object_unref0 (self->priv->component_dots);
#line 87 "../src/Widgets/calendar/GridDay.vala"
	self->priv->component_dots = _tmp20_;
#line 48 "../src/Widgets/calendar/GridDay.vala"
	_g_object_unref0 (box);
#line 48 "../src/Widgets/calendar/GridDay.vala"
	return obj;
#line 707 "GridDay.c"
}

static void
date_time_widgets_grid_day_class_init (DateTimeWidgetsGridDayClass * klass,
                                       gpointer klass_data)
{
	GtkCssProvider* _tmp0_;
	GtkCssProvider* _tmp1_;
#line 24 "../src/Widgets/calendar/GridDay.vala"
	date_time_widgets_grid_day_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/Widgets/calendar/GridDay.vala"
	g_type_class_adjust_private_offset (klass, &DateTimeWidgetsGridDay_private_offset);
#line 24 "../src/Widgets/calendar/GridDay.vala"
	((GtkWidgetClass *) klass)->grab_focus = (void (*) (GtkWidget*)) date_time_widgets_grid_day_real_grab_focus;
#line 24 "../src/Widgets/calendar/GridDay.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_date_time_widgets_grid_day_get_property;
#line 24 "../src/Widgets/calendar/GridDay.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_date_time_widgets_grid_day_set_property;
#line 24 "../src/Widgets/calendar/GridDay.vala"
	G_OBJECT_CLASS (klass)->constructor = date_time_widgets_grid_day_constructor;
#line 24 "../src/Widgets/calendar/GridDay.vala"
	G_OBJECT_CLASS (klass)->finalize = date_time_widgets_grid_day_finalize;
#line 24 "../src/Widgets/calendar/GridDay.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DATE_TIME_WIDGETS_GRID_DAY_DATE_PROPERTY, date_time_widgets_grid_day_properties[DATE_TIME_WIDGETS_GRID_DAY_DATE_PROPERTY] = g_param_spec_boxed ("date", "date", "date", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 24 "../src/Widgets/calendar/GridDay.vala"
	date_time_widgets_grid_day_signals[DATE_TIME_WIDGETS_GRID_DAY_ON_EVENT_ADD_SIGNAL] = g_signal_new ("on-event-add", DATE_TIME_WIDGETS_TYPE_GRID_DAY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOXED, G_TYPE_NONE, 1, G_TYPE_DATE_TIME);
#line 44 "../src/Widgets/calendar/GridDay.vala"
	_tmp0_ = gtk_css_provider_new ();
#line 44 "../src/Widgets/calendar/GridDay.vala"
	_g_object_unref0 (date_time_widgets_grid_day_provider);
#line 44 "../src/Widgets/calendar/GridDay.vala"
	date_time_widgets_grid_day_provider = _tmp0_;
#line 45 "../src/Widgets/calendar/GridDay.vala"
	_tmp1_ = date_time_widgets_grid_day_provider;
#line 45 "../src/Widgets/calendar/GridDay.vala"
	gtk_css_provider_load_from_resource (_tmp1_, "/io/elementary/desktop/wingpanel/datetime/GridDay.css");
#line 744 "GridDay.c"
}

static void
date_time_widgets_grid_day_instance_init (DateTimeWidgetsGridDay * self,
                                          gpointer klass)
{
#line 24 "../src/Widgets/calendar/GridDay.vala"
	self->priv = date_time_widgets_grid_day_get_instance_private (self);
#line 37 "../src/Widgets/calendar/GridDay.vala"
	self->priv->valid_grab = FALSE;
#line 755 "GridDay.c"
}

static void
date_time_widgets_grid_day_finalize (GObject * obj)
{
	DateTimeWidgetsGridDay * self;
#line 24 "../src/Widgets/calendar/GridDay.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DATE_TIME_WIDGETS_TYPE_GRID_DAY, DateTimeWidgetsGridDay);
#line 30 "../src/Widgets/calendar/GridDay.vala"
	_g_date_time_unref0 (self->priv->_date);
#line 34 "../src/Widgets/calendar/GridDay.vala"
	_g_object_unref0 (self->priv->component_dots);
#line 35 "../src/Widgets/calendar/GridDay.vala"
	_g_object_unref0 (self->priv->event_box);
#line 36 "../src/Widgets/calendar/GridDay.vala"
	_g_object_unref0 (self->priv->label);
#line 24 "../src/Widgets/calendar/GridDay.vala"
	G_OBJECT_CLASS (date_time_widgets_grid_day_parent_class)->finalize (obj);
#line 774 "GridDay.c"
}

/**
 * Represents a single day on the grid.
 */
static GType
date_time_widgets_grid_day_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DateTimeWidgetsGridDayClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) date_time_widgets_grid_day_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DateTimeWidgetsGridDay), 0, (GInstanceInitFunc) date_time_widgets_grid_day_instance_init, NULL };
	GType date_time_widgets_grid_day_type_id;
	date_time_widgets_grid_day_type_id = g_type_register_static (gtk_event_box_get_type (), "DateTimeWidgetsGridDay", &g_define_type_info, 0);
	DateTimeWidgetsGridDay_private_offset = g_type_add_instance_private (date_time_widgets_grid_day_type_id, sizeof (DateTimeWidgetsGridDayPrivate));
	return date_time_widgets_grid_day_type_id;
}

GType
date_time_widgets_grid_day_get_type (void)
{
	static volatile gsize date_time_widgets_grid_day_type_id__once = 0;
	if (g_once_init_enter (&date_time_widgets_grid_day_type_id__once)) {
		GType date_time_widgets_grid_day_type_id;
		date_time_widgets_grid_day_type_id = date_time_widgets_grid_day_get_type_once ();
		g_once_init_leave (&date_time_widgets_grid_day_type_id__once, date_time_widgets_grid_day_type_id);
	}
	return date_time_widgets_grid_day_type_id__once;
}

static void
_vala_date_time_widgets_grid_day_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec)
{
	DateTimeWidgetsGridDay * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DATE_TIME_WIDGETS_TYPE_GRID_DAY, DateTimeWidgetsGridDay);
#line 24 "../src/Widgets/calendar/GridDay.vala"
	switch (property_id) {
#line 24 "../src/Widgets/calendar/GridDay.vala"
		case DATE_TIME_WIDGETS_GRID_DAY_DATE_PROPERTY:
#line 24 "../src/Widgets/calendar/GridDay.vala"
		g_value_set_boxed (value, date_time_widgets_grid_day_get_date (self));
#line 24 "../src/Widgets/calendar/GridDay.vala"
		break;
#line 818 "GridDay.c"
		default:
#line 24 "../src/Widgets/calendar/GridDay.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/Widgets/calendar/GridDay.vala"
		break;
#line 824 "GridDay.c"
	}
}

static void
_vala_date_time_widgets_grid_day_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec)
{
	DateTimeWidgetsGridDay * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DATE_TIME_WIDGETS_TYPE_GRID_DAY, DateTimeWidgetsGridDay);
#line 24 "../src/Widgets/calendar/GridDay.vala"
	switch (property_id) {
#line 24 "../src/Widgets/calendar/GridDay.vala"
		case DATE_TIME_WIDGETS_GRID_DAY_DATE_PROPERTY:
#line 24 "../src/Widgets/calendar/GridDay.vala"
		date_time_widgets_grid_day_set_date (self, g_value_get_boxed (value));
#line 24 "../src/Widgets/calendar/GridDay.vala"
		break;
#line 844 "GridDay.c"
		default:
#line 24 "../src/Widgets/calendar/GridDay.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/Widgets/calendar/GridDay.vala"
		break;
#line 850 "GridDay.c"
	}
}

