/* Util.c generated by valac 0.56.13, the Vala compiler
 * generated from Util.vala, do not modify */

/*
 * Copyright 2011-2019 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authored by: Corentin Noël <corentin@elementaryos.org>
 */

#include "datetime.h"
#include <glib.h>
#include <float.h>
#include <math.h>
#include <libical-glib/libical-glib.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <libedataserver/libedataserver.h>
#include <libecal/libecal.h>
#include <time.h>

#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_time_zone_unref0(var) ((var == NULL) ? NULL : (var = (g_time_zone_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_ECalComponentId_free0(var) ((var == NULL) ? NULL : (var = (_vala_ECalComponentId_free (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

VALA_EXTERN GeeHashMap* util_providers;
GeeHashMap* util_providers = NULL;

static void _vala_ECalComponentId_free (ECalComponentId* self);

GDateTime*
util_get_start_of_month (GDateTime* date)
{
	GDateTime* _tmp1_;
	GDateTime* result;
#line 25 "../src/Widgets/calendar/Util.vala"
	if (date == NULL) {
#line 63 "Util.c"
		GDateTime* _tmp0_;
#line 26 "../src/Widgets/calendar/Util.vala"
		_tmp0_ = g_date_time_new_now_local ();
#line 26 "../src/Widgets/calendar/Util.vala"
		_g_date_time_unref0 (date);
#line 26 "../src/Widgets/calendar/Util.vala"
		date = _tmp0_;
#line 71 "Util.c"
	}
#line 29 "../src/Widgets/calendar/Util.vala"
	_tmp1_ = g_date_time_new_local (g_date_time_get_year (date), g_date_time_get_month (date), 1, 0, 0, (gdouble) 0);
#line 29 "../src/Widgets/calendar/Util.vala"
	result = _tmp1_;
#line 29 "../src/Widgets/calendar/Util.vala"
	_g_date_time_unref0 (date);
#line 29 "../src/Widgets/calendar/Util.vala"
	return result;
#line 81 "Util.c"
}

GDateTime*
util_strip_time (GDateTime* datetime)
{
	GDateTime* _tmp0_;
	GDateTime* result;
#line 32 "../src/Widgets/calendar/Util.vala"
	g_return_val_if_fail (datetime != NULL, NULL);
#line 33 "../src/Widgets/calendar/Util.vala"
	_tmp0_ = g_date_time_add_full (datetime, 0, 0, 0, -g_date_time_get_hour (datetime), -g_date_time_get_minute (datetime), (gdouble) (-g_date_time_get_second (datetime)));
#line 33 "../src/Widgets/calendar/Util.vala"
	result = _tmp0_;
#line 33 "../src/Widgets/calendar/Util.vala"
	return result;
#line 97 "Util.c"
}

/**
     * Gets the timezone of the given TimeType as a GLib.TimeZone.
     */
static const gchar*
string_offset (const gchar* self,
               glong offset)
{
	const gchar* result;
#line 1279 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1280 "glib-2.0.vapi"
	result = (const gchar*) (((gchar*) self) + offset);
#line 1280 "glib-2.0.vapi"
	return result;
#line 114 "Util.c"
}

GTimeZone*
util_timezone_from_ical (ICalTime* date)
{
	const gchar* tzid = NULL;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 62 "../src/Widgets/calendar/Util.vala"
	static const char LIBICAL_TZ_PREFIX[] = "/freeassociation.sourceforge.net/";
#line 125 "Util.c"
	const gchar* _tmp5_;
	GTimeZone* result;
#line 39 "../src/Widgets/calendar/Util.vala"
	g_return_val_if_fail (date != NULL, NULL);
#line 41 "../src/Widgets/calendar/Util.vala"
	if (i_cal_time_is_date (date)) {
#line 132 "Util.c"
		GTimeZone* _tmp0_;
#line 42 "../src/Widgets/calendar/Util.vala"
		_tmp0_ = g_time_zone_new_local ();
#line 42 "../src/Widgets/calendar/Util.vala"
		result = _tmp0_;
#line 42 "../src/Widgets/calendar/Util.vala"
		return result;
#line 140 "Util.c"
	}
#line 45 "../src/Widgets/calendar/Util.vala"
	_tmp1_ = i_cal_time_get_tzid (date);
#line 45 "../src/Widgets/calendar/Util.vala"
	tzid = _tmp1_;
#line 46 "../src/Widgets/calendar/Util.vala"
	_tmp2_ = tzid;
#line 46 "../src/Widgets/calendar/Util.vala"
	if (_tmp2_ == NULL) {
#line 150 "Util.c"
		ICalTimezone* _tmp3_;
		GTimeZone* _tmp4_;
#line 48 "../src/Widgets/calendar/Util.vala"
		_tmp3_ = i_cal_time_get_timezone (date);
#line 48 "../src/Widgets/calendar/Util.vala"
		_vala_assert (_tmp3_ == NULL, "date.get_timezone () == null");
#line 49 "../src/Widgets/calendar/Util.vala"
		_tmp4_ = g_time_zone_new_local ();
#line 49 "../src/Widgets/calendar/Util.vala"
		result = _tmp4_;
#line 49 "../src/Widgets/calendar/Util.vala"
		return result;
#line 163 "Util.c"
	}
#line 63 "../src/Widgets/calendar/Util.vala"
	_tmp5_ = tzid;
#line 63 "../src/Widgets/calendar/Util.vala"
	if (g_str_has_prefix (_tmp5_, LIBICAL_TZ_PREFIX)) {
#line 169 "Util.c"
		const gchar* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		const gchar* _tmp9_;
		GTimeZone* _tmp10_;
#line 66 "../src/Widgets/calendar/Util.vala"
		_tmp6_ = tzid;
#line 66 "../src/Widgets/calendar/Util.vala"
		_tmp7_ = strlen (LIBICAL_TZ_PREFIX);
#line 66 "../src/Widgets/calendar/Util.vala"
		_tmp8_ = _tmp7_;
#line 66 "../src/Widgets/calendar/Util.vala"
		_tmp9_ = string_offset (_tmp6_, (glong) _tmp8_);
#line 66 "../src/Widgets/calendar/Util.vala"
		_tmp10_ = g_time_zone_new (_tmp9_);
#line 66 "../src/Widgets/calendar/Util.vala"
		result = _tmp10_;
#line 66 "../src/Widgets/calendar/Util.vala"
		return result;
#line 189 "Util.c"
	} else {
		const gchar* _tmp11_;
		GTimeZone* _tmp12_;
#line 70 "../src/Widgets/calendar/Util.vala"
		_tmp11_ = tzid;
#line 70 "../src/Widgets/calendar/Util.vala"
		_tmp12_ = g_time_zone_new (_tmp11_);
#line 70 "../src/Widgets/calendar/Util.vala"
		result = _tmp12_;
#line 70 "../src/Widgets/calendar/Util.vala"
		return result;
#line 201 "Util.c"
	}
}

/**
     * Converts the given ICal.Time to a DateTime.
     * XXX : Track next versions of evolution in order to convert ICal.Timezone to GLib.TimeZone with a dedicated function…
     */
GDateTime*
util_ical_to_date_time (ICalTime* date)
{
	gint year = 0;
	gint month = 0;
	gint day = 0;
	gint hour = 0;
	gint minute = 0;
	gint second = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	GTimeZone* _tmp6_;
	GTimeZone* _tmp7_;
	GDateTime* _tmp8_;
	GDateTime* _tmp9_;
	GDateTime* result;
#line 78 "../src/Widgets/calendar/Util.vala"
	g_return_val_if_fail (date != NULL, NULL);
#line 81 "../src/Widgets/calendar/Util.vala"
	i_cal_time_get_date (date, &_tmp0_, &_tmp1_, &_tmp2_);
#line 81 "../src/Widgets/calendar/Util.vala"
	year = _tmp0_;
#line 81 "../src/Widgets/calendar/Util.vala"
	month = _tmp1_;
#line 81 "../src/Widgets/calendar/Util.vala"
	day = _tmp2_;
#line 82 "../src/Widgets/calendar/Util.vala"
	i_cal_time_get_time (date, &_tmp3_, &_tmp4_, &_tmp5_);
#line 82 "../src/Widgets/calendar/Util.vala"
	hour = _tmp3_;
#line 82 "../src/Widgets/calendar/Util.vala"
	minute = _tmp4_;
#line 82 "../src/Widgets/calendar/Util.vala"
	second = _tmp5_;
#line 83 "../src/Widgets/calendar/Util.vala"
	_tmp6_ = util_timezone_from_ical (date);
#line 83 "../src/Widgets/calendar/Util.vala"
	_tmp7_ = _tmp6_;
#line 83 "../src/Widgets/calendar/Util.vala"
	_tmp8_ = g_date_time_new (_tmp7_, year, month, day, hour, minute, (gdouble) second);
#line 83 "../src/Widgets/calendar/Util.vala"
	_tmp9_ = _tmp8_;
#line 83 "../src/Widgets/calendar/Util.vala"
	_g_time_zone_unref0 (_tmp7_);
#line 83 "../src/Widgets/calendar/Util.vala"
	result = _tmp9_;
#line 83 "../src/Widgets/calendar/Util.vala"
	return result;
#line 261 "Util.c"
}

/**
     * Say if an event lasts all day.
     */
gboolean
util_is_the_all_day (GDateTime* dtstart,
                     GDateTime* dtend)
{
	GDateTime* utc_start = NULL;
	GTimeZone* _tmp0_;
	GTimeZone* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	GTimeSpan timespan = 0LL;
	gboolean _tmp4_ = FALSE;
	gboolean result;
#line 94 "../src/Widgets/calendar/Util.vala"
	g_return_val_if_fail (dtstart != NULL, FALSE);
#line 94 "../src/Widgets/calendar/Util.vala"
	g_return_val_if_fail (dtend != NULL, FALSE);
#line 95 "../src/Widgets/calendar/Util.vala"
	_tmp0_ = g_time_zone_new_utc ();
#line 95 "../src/Widgets/calendar/Util.vala"
	_tmp1_ = _tmp0_;
#line 95 "../src/Widgets/calendar/Util.vala"
	_tmp2_ = g_date_time_to_timezone (dtstart, _tmp1_);
#line 95 "../src/Widgets/calendar/Util.vala"
	_tmp3_ = _tmp2_;
#line 95 "../src/Widgets/calendar/Util.vala"
	_g_time_zone_unref0 (_tmp1_);
#line 95 "../src/Widgets/calendar/Util.vala"
	utc_start = _tmp3_;
#line 96 "../src/Widgets/calendar/Util.vala"
	timespan = g_date_time_difference (dtend, dtstart);
#line 98 "../src/Widgets/calendar/Util.vala"
	if ((timespan % G_TIME_SPAN_DAY) == ((GTimeSpan) 0)) {
#line 299 "Util.c"
		GDateTime* _tmp5_;
#line 98 "../src/Widgets/calendar/Util.vala"
		_tmp5_ = utc_start;
#line 98 "../src/Widgets/calendar/Util.vala"
		_tmp4_ = g_date_time_get_hour (_tmp5_) == 0;
#line 305 "Util.c"
	} else {
#line 98 "../src/Widgets/calendar/Util.vala"
		_tmp4_ = FALSE;
#line 309 "Util.c"
	}
#line 98 "../src/Widgets/calendar/Util.vala"
	if (_tmp4_) {
#line 99 "../src/Widgets/calendar/Util.vala"
		result = TRUE;
#line 99 "../src/Widgets/calendar/Util.vala"
		_g_date_time_unref0 (utc_start);
#line 99 "../src/Widgets/calendar/Util.vala"
		return result;
#line 319 "Util.c"
	} else {
#line 101 "../src/Widgets/calendar/Util.vala"
		result = FALSE;
#line 101 "../src/Widgets/calendar/Util.vala"
		_g_date_time_unref0 (utc_start);
#line 101 "../src/Widgets/calendar/Util.vala"
		return result;
#line 327 "Util.c"
	}
}

void
util_set_component_calendar_color (ESourceSelectable* selectable,
                                   GtkWidget* widget)
{
	GeeHashMap* _tmp0_;
	gchar* color = NULL;
	gchar* _tmp2_;
	GeeHashMap* _tmp3_;
	const gchar* _tmp4_;
	GtkStyleContext* style_context = NULL;
	GtkStyleContext* _tmp18_;
	GeeHashMap* _tmp19_;
	const gchar* _tmp20_;
	gpointer _tmp21_;
	GtkCssProvider* _tmp22_;
	GError* _inner_error0_ = NULL;
#line 106 "../src/Widgets/calendar/Util.vala"
	g_return_if_fail (selectable != NULL);
#line 106 "../src/Widgets/calendar/Util.vala"
	g_return_if_fail (widget != NULL);
#line 107 "../src/Widgets/calendar/Util.vala"
	_tmp0_ = util_providers;
#line 107 "../src/Widgets/calendar/Util.vala"
	if (_tmp0_ == NULL) {
#line 355 "Util.c"
		GeeHashMap* _tmp1_;
#line 108 "../src/Widgets/calendar/Util.vala"
		_tmp1_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, gtk_css_provider_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 108 "../src/Widgets/calendar/Util.vala"
		_g_object_unref0 (util_providers);
#line 108 "../src/Widgets/calendar/Util.vala"
		util_providers = _tmp1_;
#line 363 "Util.c"
	}
#line 111 "../src/Widgets/calendar/Util.vala"
	_tmp2_ = e_source_selectable_dup_color (selectable);
#line 111 "../src/Widgets/calendar/Util.vala"
	color = _tmp2_;
#line 112 "../src/Widgets/calendar/Util.vala"
	_tmp3_ = util_providers;
#line 112 "../src/Widgets/calendar/Util.vala"
	_tmp4_ = color;
#line 112 "../src/Widgets/calendar/Util.vala"
	if (!gee_abstract_map_has_key ((GeeAbstractMap*) _tmp3_, _tmp4_)) {
#line 375 "Util.c"
		gchar* style = NULL;
		const gchar* _tmp5_;
		gchar* _tmp6_;
#line 113 "../src/Widgets/calendar/Util.vala"
		_tmp5_ = color;
#line 113 "../src/Widgets/calendar/Util.vala"
		_tmp6_ = g_strdup_printf ("\n                @define-color accent_color %s;\n            ", _tmp5_);
#line 113 "../src/Widgets/calendar/Util.vala"
		style = _tmp6_;
#line 385 "Util.c"
		{
			GtkCssProvider* style_provider = NULL;
			GtkCssProvider* _tmp7_;
			GtkCssProvider* _tmp8_;
			const gchar* _tmp9_;
			const gchar* _tmp10_;
			gint _tmp11_;
			gint _tmp12_;
			GeeHashMap* _tmp13_;
			const gchar* _tmp14_;
			GtkCssProvider* _tmp15_;
#line 118 "../src/Widgets/calendar/Util.vala"
			_tmp7_ = gtk_css_provider_new ();
#line 118 "../src/Widgets/calendar/Util.vala"
			style_provider = _tmp7_;
#line 119 "../src/Widgets/calendar/Util.vala"
			_tmp8_ = style_provider;
#line 119 "../src/Widgets/calendar/Util.vala"
			_tmp9_ = style;
#line 119 "../src/Widgets/calendar/Util.vala"
			_tmp10_ = style;
#line 119 "../src/Widgets/calendar/Util.vala"
			_tmp11_ = strlen (_tmp10_);
#line 119 "../src/Widgets/calendar/Util.vala"
			_tmp12_ = _tmp11_;
#line 119 "../src/Widgets/calendar/Util.vala"
			gtk_css_provider_load_from_data (_tmp8_, _tmp9_, (gssize) _tmp12_, &_inner_error0_);
#line 119 "../src/Widgets/calendar/Util.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 119 "../src/Widgets/calendar/Util.vala"
				_g_object_unref0 (style_provider);
#line 417 "Util.c"
				goto __catch0_g_error;
			}
#line 121 "../src/Widgets/calendar/Util.vala"
			_tmp13_ = util_providers;
#line 121 "../src/Widgets/calendar/Util.vala"
			_tmp14_ = color;
#line 121 "../src/Widgets/calendar/Util.vala"
			_tmp15_ = style_provider;
#line 121 "../src/Widgets/calendar/Util.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp13_, _tmp14_, _tmp15_);
#line 117 "../src/Widgets/calendar/Util.vala"
			_g_object_unref0 (style_provider);
#line 430 "Util.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp16_;
			const gchar* _tmp17_;
#line 117 "../src/Widgets/calendar/Util.vala"
			e = _inner_error0_;
#line 117 "../src/Widgets/calendar/Util.vala"
			_inner_error0_ = NULL;
#line 123 "../src/Widgets/calendar/Util.vala"
			_tmp16_ = e;
#line 123 "../src/Widgets/calendar/Util.vala"
			_tmp17_ = _tmp16_->message;
#line 123 "../src/Widgets/calendar/Util.vala"
			g_critical ("Util.vala:123: Unable to set calendar color: %s", _tmp17_);
#line 117 "../src/Widgets/calendar/Util.vala"
			_g_error_free0 (e);
#line 450 "Util.c"
		}
		__finally0:
#line 117 "../src/Widgets/calendar/Util.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 117 "../src/Widgets/calendar/Util.vala"
			_g_free0 (style);
#line 117 "../src/Widgets/calendar/Util.vala"
			_g_free0 (color);
#line 117 "../src/Widgets/calendar/Util.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 117 "../src/Widgets/calendar/Util.vala"
			g_clear_error (&_inner_error0_);
#line 117 "../src/Widgets/calendar/Util.vala"
			return;
#line 465 "Util.c"
		}
#line 112 "../src/Widgets/calendar/Util.vala"
		_g_free0 (style);
#line 469 "Util.c"
	}
#line 127 "../src/Widgets/calendar/Util.vala"
	_tmp18_ = gtk_widget_get_style_context (widget);
#line 127 "../src/Widgets/calendar/Util.vala"
	style_context = _tmp18_;
#line 128 "../src/Widgets/calendar/Util.vala"
	_tmp19_ = util_providers;
#line 128 "../src/Widgets/calendar/Util.vala"
	_tmp20_ = color;
#line 128 "../src/Widgets/calendar/Util.vala"
	_tmp21_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp19_, _tmp20_);
#line 128 "../src/Widgets/calendar/Util.vala"
	_tmp22_ = (GtkCssProvider*) _tmp21_;
#line 128 "../src/Widgets/calendar/Util.vala"
	gtk_style_context_add_provider (style_context, (GtkStyleProvider*) _tmp22_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 128 "../src/Widgets/calendar/Util.vala"
	_g_object_unref0 (_tmp22_);
#line 106 "../src/Widgets/calendar/Util.vala"
	_g_free0 (color);
#line 489 "Util.c"
}

guint
util_source_hash_func (ESource* key)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	guint _tmp2_;
	guint result;
#line 136 "../src/Widgets/calendar/Util.vala"
	g_return_val_if_fail (key != NULL, 0U);
#line 137 "../src/Widgets/calendar/Util.vala"
	_tmp0_ = e_source_dup_uid (key);
#line 137 "../src/Widgets/calendar/Util.vala"
	_tmp1_ = _tmp0_;
#line 137 "../src/Widgets/calendar/Util.vala"
	_tmp2_ = g_str_hash (_tmp1_);
#line 137 "../src/Widgets/calendar/Util.vala"
	_g_free0 (_tmp1_);
#line 137 "../src/Widgets/calendar/Util.vala"
	result = _tmp2_;
#line 137 "../src/Widgets/calendar/Util.vala"
	return result;
#line 513 "Util.c"
}

static void
_vala_ECalComponentId_free (ECalComponentId* self)
{
#line 142 "../src/Widgets/calendar/Util.vala"
	g_boxed_free (e_cal_component_id_get_type (), self);
#line 521 "Util.c"
}

gboolean
util_calcomponent_equal_func (ECalComponent* a,
                              ECalComponent* b)
{
	ECalComponentId* _tmp0_;
	ECalComponentId* _tmp1_;
	ECalComponentId* _tmp2_;
	ECalComponentId* _tmp3_;
	gboolean _tmp4_;
	gboolean result;
#line 141 "../src/Widgets/calendar/Util.vala"
	g_return_val_if_fail (a != NULL, FALSE);
#line 141 "../src/Widgets/calendar/Util.vala"
	g_return_val_if_fail (b != NULL, FALSE);
#line 142 "../src/Widgets/calendar/Util.vala"
	_tmp0_ = e_cal_component_get_id (a);
#line 142 "../src/Widgets/calendar/Util.vala"
	_tmp1_ = _tmp0_;
#line 142 "../src/Widgets/calendar/Util.vala"
	_tmp2_ = e_cal_component_get_id (b);
#line 142 "../src/Widgets/calendar/Util.vala"
	_tmp3_ = _tmp2_;
#line 142 "../src/Widgets/calendar/Util.vala"
	_tmp4_ = e_cal_component_id_equal (_tmp1_, _tmp3_);
#line 142 "../src/Widgets/calendar/Util.vala"
	__vala_ECalComponentId_free0 (_tmp3_);
#line 142 "../src/Widgets/calendar/Util.vala"
	__vala_ECalComponentId_free0 (_tmp1_);
#line 142 "../src/Widgets/calendar/Util.vala"
	result = _tmp4_;
#line 142 "../src/Widgets/calendar/Util.vala"
	return result;
#line 556 "Util.c"
}

gint
util_calcomponent_compare_func (ECalComponent* a,
                                ECalComponent* b)
{
	gboolean _tmp0_ = FALSE;
	ECalComponentId* a_id = NULL;
	ECalComponentId* _tmp3_;
	ECalComponentId* b_id = NULL;
	ECalComponentId* _tmp4_;
	gint res = 0;
	GCompareFunc _tmp5_;
	ECalComponentId* _tmp6_;
	const gchar* _tmp7_;
	ECalComponentId* _tmp8_;
	const gchar* _tmp9_;
	gint result;
#line 146 "../src/Widgets/calendar/Util.vala"
	if (a == NULL) {
#line 146 "../src/Widgets/calendar/Util.vala"
		_tmp0_ = b != NULL;
#line 579 "Util.c"
	} else {
#line 146 "../src/Widgets/calendar/Util.vala"
		_tmp0_ = FALSE;
#line 583 "Util.c"
	}
#line 146 "../src/Widgets/calendar/Util.vala"
	if (_tmp0_) {
#line 147 "../src/Widgets/calendar/Util.vala"
		result = 1;
#line 147 "../src/Widgets/calendar/Util.vala"
		return result;
#line 591 "Util.c"
	} else {
		gboolean _tmp1_ = FALSE;
#line 148 "../src/Widgets/calendar/Util.vala"
		if (b == NULL) {
#line 148 "../src/Widgets/calendar/Util.vala"
			_tmp1_ = a != NULL;
#line 598 "Util.c"
		} else {
#line 148 "../src/Widgets/calendar/Util.vala"
			_tmp1_ = FALSE;
#line 602 "Util.c"
		}
#line 148 "../src/Widgets/calendar/Util.vala"
		if (_tmp1_) {
#line 149 "../src/Widgets/calendar/Util.vala"
			result = -1;
#line 149 "../src/Widgets/calendar/Util.vala"
			return result;
#line 610 "Util.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 150 "../src/Widgets/calendar/Util.vala"
			if (b == NULL) {
#line 150 "../src/Widgets/calendar/Util.vala"
				_tmp2_ = a == NULL;
#line 617 "Util.c"
			} else {
#line 150 "../src/Widgets/calendar/Util.vala"
				_tmp2_ = FALSE;
#line 621 "Util.c"
			}
#line 150 "../src/Widgets/calendar/Util.vala"
			if (_tmp2_) {
#line 151 "../src/Widgets/calendar/Util.vala"
				result = 0;
#line 151 "../src/Widgets/calendar/Util.vala"
				return result;
#line 629 "Util.c"
			}
		}
	}
#line 154 "../src/Widgets/calendar/Util.vala"
	_tmp3_ = e_cal_component_get_id (a);
#line 154 "../src/Widgets/calendar/Util.vala"
	a_id = _tmp3_;
#line 155 "../src/Widgets/calendar/Util.vala"
	_tmp4_ = e_cal_component_get_id (b);
#line 155 "../src/Widgets/calendar/Util.vala"
	b_id = _tmp4_;
#line 156 "../src/Widgets/calendar/Util.vala"
	_tmp5_ = ((GCompareFunc) g_strcmp0);
#line 156 "../src/Widgets/calendar/Util.vala"
	_tmp6_ = a_id;
#line 156 "../src/Widgets/calendar/Util.vala"
	_tmp7_ = e_cal_component_id_get_uid (_tmp6_);
#line 156 "../src/Widgets/calendar/Util.vala"
	_tmp8_ = b_id;
#line 156 "../src/Widgets/calendar/Util.vala"
	_tmp9_ = e_cal_component_id_get_uid (_tmp8_);
#line 156 "../src/Widgets/calendar/Util.vala"
	res = _tmp5_ (_tmp7_, _tmp9_);
#line 157 "../src/Widgets/calendar/Util.vala"
	if (res == 0) {
#line 655 "Util.c"
		GCompareFunc _tmp10_;
		ECalComponentId* _tmp11_;
		const gchar* _tmp12_;
		ECalComponentId* _tmp13_;
		const gchar* _tmp14_;
#line 158 "../src/Widgets/calendar/Util.vala"
		_tmp10_ = ((GCompareFunc) g_strcmp0);
#line 158 "../src/Widgets/calendar/Util.vala"
		_tmp11_ = a_id;
#line 158 "../src/Widgets/calendar/Util.vala"
		_tmp12_ = e_cal_component_id_get_rid (_tmp11_);
#line 158 "../src/Widgets/calendar/Util.vala"
		_tmp13_ = b_id;
#line 158 "../src/Widgets/calendar/Util.vala"
		_tmp14_ = e_cal_component_id_get_rid (_tmp13_);
#line 158 "../src/Widgets/calendar/Util.vala"
		result = _tmp10_ (_tmp12_, _tmp14_);
#line 158 "../src/Widgets/calendar/Util.vala"
		__vala_ECalComponentId_free0 (b_id);
#line 158 "../src/Widgets/calendar/Util.vala"
		__vala_ECalComponentId_free0 (a_id);
#line 158 "../src/Widgets/calendar/Util.vala"
		return result;
#line 679 "Util.c"
	}
#line 161 "../src/Widgets/calendar/Util.vala"
	result = res;
#line 161 "../src/Widgets/calendar/Util.vala"
	__vala_ECalComponentId_free0 (b_id);
#line 161 "../src/Widgets/calendar/Util.vala"
	__vala_ECalComponentId_free0 (a_id);
#line 161 "../src/Widgets/calendar/Util.vala"
	return result;
#line 689 "Util.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 187 "../src/Widgets/calendar/Util.vala"
	return self ? g_object_ref (self) : NULL;
#line 697 "Util.c"
}

gboolean
util_calcomp_is_on_day (ECalComponent* comp,
                        GDateTime* day)
{
	ICalTimezone* system_timezone = NULL;
	ICalTimezone* _tmp0_;
	GDateTime* stripped_time = NULL;
	GDateTime* _tmp1_;
	gint64 selected_date_unix = 0LL;
	GDateTime* _tmp2_;
	gint64 selected_date_unix_next = 0LL;
	GDateTime* _tmp3_;
	GDateTime* _tmp4_;
	GDateTime* _tmp5_;
	gint64 _tmp6_;
	ICalComponent* icomp = NULL;
	ICalComponent* _tmp7_;
	ICalTime* start_time = NULL;
	ICalComponent* _tmp8_;
	ICalTime* _tmp9_;
	ICalTime* due_time = NULL;
	ICalComponent* _tmp10_;
	ICalTime* _tmp11_;
	ICalTime* end_time = NULL;
	ICalComponent* _tmp12_;
	ICalTime* _tmp13_;
	gboolean _tmp14_ = FALSE;
	ICalTime* _tmp15_;
	time_t start_unix = 0;
	ICalTime* _tmp24_;
	ICalTimezone* _tmp25_;
	time_t end_unix = 0;
	ICalTime* _tmp26_;
	ICalTimezone* _tmp27_;
	gboolean _tmp28_ = FALSE;
	gboolean _tmp29_ = FALSE;
	gboolean _tmp30_ = FALSE;
	gboolean _tmp31_ = FALSE;
	gboolean result;
#line 164 "../src/Widgets/calendar/Util.vala"
	g_return_val_if_fail (comp != NULL, FALSE);
#line 164 "../src/Widgets/calendar/Util.vala"
	g_return_val_if_fail (day != NULL, FALSE);
#line 166 "../src/Widgets/calendar/Util.vala"
	_tmp0_ = e_cal_util_get_system_timezone ();
#line 166 "../src/Widgets/calendar/Util.vala"
	system_timezone = _tmp0_;
#line 171 "../src/Widgets/calendar/Util.vala"
	_tmp1_ = g_date_time_new_local (g_date_time_get_year (day), g_date_time_get_month (day), g_date_time_get_day_of_month (day), 0, 0, (gdouble) 0);
#line 171 "../src/Widgets/calendar/Util.vala"
	stripped_time = _tmp1_;
#line 173 "../src/Widgets/calendar/Util.vala"
	_tmp2_ = stripped_time;
#line 173 "../src/Widgets/calendar/Util.vala"
	selected_date_unix = g_date_time_to_unix (_tmp2_);
#line 174 "../src/Widgets/calendar/Util.vala"
	_tmp3_ = stripped_time;
#line 174 "../src/Widgets/calendar/Util.vala"
	_tmp4_ = g_date_time_add_days (_tmp3_, 1);
#line 174 "../src/Widgets/calendar/Util.vala"
	_tmp5_ = _tmp4_;
#line 174 "../src/Widgets/calendar/Util.vala"
	_tmp6_ = g_date_time_to_unix (_tmp5_);
#line 174 "../src/Widgets/calendar/Util.vala"
	_g_date_time_unref0 (_tmp5_);
#line 174 "../src/Widgets/calendar/Util.vala"
	selected_date_unix_next = _tmp6_;
#line 177 "../src/Widgets/calendar/Util.vala"
	_tmp7_ = e_cal_component_get_icalcomponent (comp);
#line 177 "../src/Widgets/calendar/Util.vala"
	icomp = _tmp7_;
#line 178 "../src/Widgets/calendar/Util.vala"
	_tmp8_ = icomp;
#line 178 "../src/Widgets/calendar/Util.vala"
	_tmp9_ = i_cal_component_get_dtstart (_tmp8_);
#line 178 "../src/Widgets/calendar/Util.vala"
	start_time = _tmp9_;
#line 179 "../src/Widgets/calendar/Util.vala"
	_tmp10_ = icomp;
#line 179 "../src/Widgets/calendar/Util.vala"
	_tmp11_ = i_cal_component_get_due (_tmp10_);
#line 179 "../src/Widgets/calendar/Util.vala"
	due_time = _tmp11_;
#line 180 "../src/Widgets/calendar/Util.vala"
	_tmp12_ = icomp;
#line 180 "../src/Widgets/calendar/Util.vala"
	_tmp13_ = i_cal_component_get_dtend (_tmp12_);
#line 180 "../src/Widgets/calendar/Util.vala"
	end_time = _tmp13_;
#line 182 "../src/Widgets/calendar/Util.vala"
	_tmp15_ = due_time;
#line 182 "../src/Widgets/calendar/Util.vala"
	if (_tmp15_ != NULL) {
#line 793 "Util.c"
		ICalTime* _tmp16_;
#line 182 "../src/Widgets/calendar/Util.vala"
		_tmp16_ = due_time;
#line 182 "../src/Widgets/calendar/Util.vala"
		_tmp14_ = !i_cal_time_is_null_time (_tmp16_);
#line 799 "Util.c"
	} else {
#line 182 "../src/Widgets/calendar/Util.vala"
		_tmp14_ = FALSE;
#line 803 "Util.c"
	}
#line 182 "../src/Widgets/calendar/Util.vala"
	if (_tmp14_) {
#line 807 "Util.c"
		ICalTime* _tmp17_;
		ICalTime* _tmp18_;
		gboolean _tmp19_ = FALSE;
		ICalTime* _tmp20_;
#line 187 "../src/Widgets/calendar/Util.vala"
		_tmp17_ = due_time;
#line 187 "../src/Widgets/calendar/Util.vala"
		_tmp18_ = _g_object_ref0 (_tmp17_);
#line 187 "../src/Widgets/calendar/Util.vala"
		_g_object_unref0 (end_time);
#line 187 "../src/Widgets/calendar/Util.vala"
		end_time = _tmp18_;
#line 189 "../src/Widgets/calendar/Util.vala"
		_tmp20_ = start_time;
#line 189 "../src/Widgets/calendar/Util.vala"
		if (_tmp20_ == NULL) {
#line 189 "../src/Widgets/calendar/Util.vala"
			_tmp19_ = TRUE;
#line 826 "Util.c"
		} else {
			ICalTime* _tmp21_;
#line 189 "../src/Widgets/calendar/Util.vala"
			_tmp21_ = start_time;
#line 189 "../src/Widgets/calendar/Util.vala"
			_tmp19_ = i_cal_time_is_null_time (_tmp21_);
#line 833 "Util.c"
		}
#line 189 "../src/Widgets/calendar/Util.vala"
		if (_tmp19_) {
#line 837 "Util.c"
			ICalTime* _tmp22_;
			ICalTime* _tmp23_;
#line 190 "../src/Widgets/calendar/Util.vala"
			_tmp22_ = due_time;
#line 190 "../src/Widgets/calendar/Util.vala"
			_tmp23_ = _g_object_ref0 (_tmp22_);
#line 190 "../src/Widgets/calendar/Util.vala"
			_g_object_unref0 (start_time);
#line 190 "../src/Widgets/calendar/Util.vala"
			start_time = _tmp23_;
#line 848 "Util.c"
		}
	}
#line 194 "../src/Widgets/calendar/Util.vala"
	_tmp24_ = start_time;
#line 194 "../src/Widgets/calendar/Util.vala"
	_tmp25_ = system_timezone;
#line 194 "../src/Widgets/calendar/Util.vala"
	start_unix = (time_t) i_cal_time_as_timet_with_zone (_tmp24_, _tmp25_);
#line 195 "../src/Widgets/calendar/Util.vala"
	_tmp26_ = end_time;
#line 195 "../src/Widgets/calendar/Util.vala"
	_tmp27_ = system_timezone;
#line 195 "../src/Widgets/calendar/Util.vala"
	end_unix = (time_t) i_cal_time_as_timet_with_zone (_tmp26_, _tmp27_);
#line 198 "../src/Widgets/calendar/Util.vala"
	if (((gint64) start_unix) < selected_date_unix) {
#line 198 "../src/Widgets/calendar/Util.vala"
		_tmp28_ = selected_date_unix_next < ((gint64) end_unix);
#line 867 "Util.c"
	} else {
#line 198 "../src/Widgets/calendar/Util.vala"
		_tmp28_ = FALSE;
#line 871 "Util.c"
	}
#line 198 "../src/Widgets/calendar/Util.vala"
	if (_tmp28_) {
#line 199 "../src/Widgets/calendar/Util.vala"
		result = TRUE;
#line 199 "../src/Widgets/calendar/Util.vala"
		_g_object_unref0 (end_time);
#line 199 "../src/Widgets/calendar/Util.vala"
		_g_object_unref0 (due_time);
#line 199 "../src/Widgets/calendar/Util.vala"
		_g_object_unref0 (start_time);
#line 199 "../src/Widgets/calendar/Util.vala"
		_g_date_time_unref0 (stripped_time);
#line 199 "../src/Widgets/calendar/Util.vala"
		return result;
#line 887 "Util.c"
	}
#line 203 "../src/Widgets/calendar/Util.vala"
	if (((gint64) start_unix) < selected_date_unix) {
#line 203 "../src/Widgets/calendar/Util.vala"
		_tmp29_ = selected_date_unix < ((gint64) end_unix);
#line 893 "Util.c"
	} else {
#line 203 "../src/Widgets/calendar/Util.vala"
		_tmp29_ = FALSE;
#line 897 "Util.c"
	}
#line 203 "../src/Widgets/calendar/Util.vala"
	if (_tmp29_) {
#line 204 "../src/Widgets/calendar/Util.vala"
		result = TRUE;
#line 204 "../src/Widgets/calendar/Util.vala"
		_g_object_unref0 (end_time);
#line 204 "../src/Widgets/calendar/Util.vala"
		_g_object_unref0 (due_time);
#line 204 "../src/Widgets/calendar/Util.vala"
		_g_object_unref0 (start_time);
#line 204 "../src/Widgets/calendar/Util.vala"
		_g_date_time_unref0 (stripped_time);
#line 204 "../src/Widgets/calendar/Util.vala"
		return result;
#line 913 "Util.c"
	}
#line 208 "../src/Widgets/calendar/Util.vala"
	if (((gint64) start_unix) < selected_date_unix_next) {
#line 208 "../src/Widgets/calendar/Util.vala"
		_tmp30_ = selected_date_unix_next < ((gint64) end_unix);
#line 919 "Util.c"
	} else {
#line 208 "../src/Widgets/calendar/Util.vala"
		_tmp30_ = FALSE;
#line 923 "Util.c"
	}
#line 208 "../src/Widgets/calendar/Util.vala"
	if (_tmp30_) {
#line 209 "../src/Widgets/calendar/Util.vala"
		result = TRUE;
#line 209 "../src/Widgets/calendar/Util.vala"
		_g_object_unref0 (end_time);
#line 209 "../src/Widgets/calendar/Util.vala"
		_g_object_unref0 (due_time);
#line 209 "../src/Widgets/calendar/Util.vala"
		_g_object_unref0 (start_time);
#line 209 "../src/Widgets/calendar/Util.vala"
		_g_date_time_unref0 (stripped_time);
#line 209 "../src/Widgets/calendar/Util.vala"
		return result;
#line 939 "Util.c"
	}
#line 213 "../src/Widgets/calendar/Util.vala"
	if (((gint64) start_unix) < selected_date_unix_next) {
#line 213 "../src/Widgets/calendar/Util.vala"
		_tmp31_ = selected_date_unix < ((gint64) end_unix);
#line 945 "Util.c"
	} else {
#line 213 "../src/Widgets/calendar/Util.vala"
		_tmp31_ = FALSE;
#line 949 "Util.c"
	}
#line 213 "../src/Widgets/calendar/Util.vala"
	if (_tmp31_) {
#line 214 "../src/Widgets/calendar/Util.vala"
		result = TRUE;
#line 214 "../src/Widgets/calendar/Util.vala"
		_g_object_unref0 (end_time);
#line 214 "../src/Widgets/calendar/Util.vala"
		_g_object_unref0 (due_time);
#line 214 "../src/Widgets/calendar/Util.vala"
		_g_object_unref0 (start_time);
#line 214 "../src/Widgets/calendar/Util.vala"
		_g_date_time_unref0 (stripped_time);
#line 214 "../src/Widgets/calendar/Util.vala"
		return result;
#line 965 "Util.c"
	}
#line 217 "../src/Widgets/calendar/Util.vala"
	result = FALSE;
#line 217 "../src/Widgets/calendar/Util.vala"
	_g_object_unref0 (end_time);
#line 217 "../src/Widgets/calendar/Util.vala"
	_g_object_unref0 (due_time);
#line 217 "../src/Widgets/calendar/Util.vala"
	_g_object_unref0 (start_time);
#line 217 "../src/Widgets/calendar/Util.vala"
	_g_date_time_unref0 (stripped_time);
#line 217 "../src/Widgets/calendar/Util.vala"
	return result;
#line 979 "Util.c"
}

gboolean
util_source_equal_func (ESource* a,
                        ESource* b)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_;
	gboolean result;
#line 221 "../src/Widgets/calendar/Util.vala"
	g_return_val_if_fail (a != NULL, FALSE);
#line 221 "../src/Widgets/calendar/Util.vala"
	g_return_val_if_fail (b != NULL, FALSE);
#line 222 "../src/Widgets/calendar/Util.vala"
	_tmp0_ = e_source_dup_uid (a);
#line 222 "../src/Widgets/calendar/Util.vala"
	_tmp1_ = _tmp0_;
#line 222 "../src/Widgets/calendar/Util.vala"
	_tmp2_ = e_source_dup_uid (b);
#line 222 "../src/Widgets/calendar/Util.vala"
	_tmp3_ = _tmp2_;
#line 222 "../src/Widgets/calendar/Util.vala"
	_tmp4_ = g_strcmp0 (_tmp1_, _tmp3_) == 0;
#line 222 "../src/Widgets/calendar/Util.vala"
	_g_free0 (_tmp3_);
#line 222 "../src/Widgets/calendar/Util.vala"
	_g_free0 (_tmp1_);
#line 222 "../src/Widgets/calendar/Util.vala"
	result = _tmp4_;
#line 222 "../src/Widgets/calendar/Util.vala"
	return result;
#line 1014 "Util.c"
}

